PROGRAM ETPCREL8;
USES    CRT,TURBO3;

VAR     RY1Stas,RY2Stas,RY3Stas,RY4Stas : Integer;
        RY5Stas,RY6Stas,RY7Stas,RY8Stas : Integer;
        IN1Stas,IN2Stas,IN3Stas,IN4Stas : Integer;
        IN5Stas,IN6Stas,IN7Stas,IN8Stas : Integer;
        RelayUser : Integer;
        OutPort,InPort,OldPort : Byte;
        Ch        : Char;
        Quit,Exit : Boolean;


TYPE    ArayOn    = ARRAY [0..8] of Byte;
        ArayOff   = ARRAY [0..8] of Byte;
        ArayStas  = ARRAY [0..1] of String[3];
        ArayColor = ARRAY [0..1] of Integer;

CONST   Esc       = #27;
        Space     = #32;
        DataOn    : ArayOn    = ($00,$01,$02,$04,$08,$10,$20,$40,$80);
        DataOff   : ArayOff   = ($FF,$FE,$FD,$FB,$F7,$EF,$DF,$BF,$7F);
        OutStas   : ArayStas  = ('OFF','ON ');
        InStas    : ArayStas  = (' 0 ',' 1 ');
        ColorStas : ArayColor = (15,10);

PROCEDURE OnRelay;
BEGIN
     TextBackground(Blue);
     TextColor(Yellow);
     Gotoxy(15,10);Writeln('ͻ');
     Gotoxy(15,11);Writeln(' Status Now : Ch1  Ch2  Ch3  Ch4  Ch5  Ch6  Ch7  Ch8 ');
     Gotoxy(15,12);Writeln('                                                     ');
     Gotoxy(15,13);Writeln(' Enter Channel Number of Relay 1..8 for ON   :       ');
     Gotoxy(15,14);Writeln('ͼ');
     Gotoxy(30,12);TextColor(ColorStas[RY1STAS]);Write(OutStas[RY1Stas]);  {Relay1 Status}
     Gotoxy(35,12);TextColor(ColorStas[RY2STAS]);Write(OutStas[RY2Stas]);  {Relay1 Status}
     Gotoxy(40,12);TextColor(ColorStas[RY3STAS]);Write(OutStas[RY3Stas]);  {Relay1 Status}
     Gotoxy(45,12);TextColor(ColorStas[RY4STAS]);Write(OutStas[RY4Stas]);  {Relay1 Status}
     Gotoxy(50,12);TextColor(ColorStas[RY5STAS]);Write(OutStas[RY5Stas]);  {Relay1 Status}
     Gotoxy(55,12);TextColor(ColorStas[RY6STAS]);Write(OutStas[RY6Stas]);  {Relay1 Status}
     Gotoxy(60,12);TextColor(ColorStas[RY7STAS]);Write(OutStas[RY7Stas]);  {Relay1 Status}
     Gotoxy(65,12);TextColor(ColorStas[RY8STAS]);Write(OutStas[RY8Stas]);  {Relay1 Status}
     Repeat
        Exit := False;
        TextColor(11);
        Gotoxy(64,13);
        Ch := Readkey;
        CASE Ch OF
           '1' : BEGIN
                  RY1Stas := 1;
                  RelayUser := 1;
                  Exit := True;
                 END;
           '2' : BEGIN
                  RY2Stas := 1;
                  RelayUser := 2;
                  Exit := True;
                 END;
           '3' : BEGIN
                  RY3Stas := 1;
                  RelayUser := 3;
                  Exit := True;
                 END;
           '4' : BEGIN
                  RY4Stas := 1;
                  RelayUser := 4;
                  Exit := True;
                 END;
           '5' : BEGIN
                  RY5Stas := 1;
                  RelayUser := 5;
                  Exit := True;
                 END;
           '6' : BEGIN
                  RY6Stas := 1;
                  RelayUser := 6;
                  Exit := True;
                 END;
           '7' : BEGIN
                  RY7Stas := 1;
                  RelayUser := 7;
                  Exit := True;
                 END;
           '8' : BEGIN
                  RY8Stas := 1;
                  RelayUser := 8;
                  Exit := True;
                 END;
           Esc : BEGIN
                  RelayUser := 0;
                  Exit := True;
                 END;
        ELSE Exit := False;
        END;
     Until Exit = True;
     OutPort := Port[$300];
     OutPort := OutPort OR DataOn[RelayUser];
     Port[$300] := OutPort;  {On Relay}
     TextColor(0);           {Clear Menu Setup}
     TextBackground(0);
     Clrscr;
END;

PROCEDURE OffRelay;
BEGIN
     TextBackground(Blue);
     TextColor(Yellow);
     Gotoxy(15,10);Writeln('ͻ');
     Gotoxy(15,11);Writeln(' Status Now : Ch1  Ch2  Ch3  Ch4  Ch5  Ch6  Ch7  Ch8 ');
     Gotoxy(15,12);Writeln('                                                     ');
     Gotoxy(15,13);Writeln(' Enter Channel Number of Relay 1..8 for OFF  :       ');
     Gotoxy(15,14);Writeln('ͼ');
     Gotoxy(30,12);TextColor(ColorStas[RY1STAS]);Write(OutStas[RY1Stas]);  {Relay1 Status}
     Gotoxy(35,12);TextColor(ColorStas[RY2STAS]);Write(OutStas[RY2Stas]);  {Relay1 Status}
     Gotoxy(40,12);TextColor(ColorStas[RY3STAS]);Write(OutStas[RY3Stas]);  {Relay1 Status}
     Gotoxy(45,12);TextColor(ColorStas[RY4STAS]);Write(OutStas[RY4Stas]);  {Relay1 Status}
     Gotoxy(50,12);TextColor(ColorStas[RY5STAS]);Write(OutStas[RY5Stas]);  {Relay1 Status}
     Gotoxy(55,12);TextColor(ColorStas[RY6STAS]);Write(OutStas[RY6Stas]);  {Relay1 Status}
     Gotoxy(60,12);TextColor(ColorStas[RY7STAS]);Write(OutStas[RY7Stas]);  {Relay1 Status}
     Gotoxy(65,12);TextColor(ColorStas[RY8STAS]);Write(OutStas[RY8Stas]);  {Relay1 Status}
     Repeat
        Exit := False;
        TextColor(11);
        Gotoxy(64,13);
        Ch := Readkey;
        CASE Ch OF
           '1' : BEGIN
                  RY1Stas := 0;
                  RelayUser := 1;
                  Exit := True;
                 END;
           '2' : BEGIN
                  RY2Stas := 0;
                  RelayUser := 2;
                  Exit := True;
                 END;
           '3' : BEGIN
                  RY3Stas := 0;
                  RelayUser := 3;
                  Exit := True;
                 END;
           '4' : BEGIN
                  RY4Stas := 0;
                  RelayUser := 4;
                  Exit := True;
                 END;
           '5' : BEGIN
                  RY5Stas := 0;
                  RelayUser := 5;
                  Exit := True;
                 END;
           '6' : BEGIN
                  RY6Stas := 0;
                  RelayUser := 6;
                  Exit := True;
                 END;
           '7' : BEGIN
                  RY7Stas := 0;
                  RelayUser := 7;
                  Exit := True;
                 END;
           '8' : BEGIN
                  RY8Stas := 0;
                  RelayUser := 8;
                  Exit := True;
                 END;
           Esc : BEGIN
                  RelayUser := 0;
                  Exit := True;
                 END;
        ELSE Exit := False;
        END;
     Until Exit = True;
     OutPort := Port[$300];
     OutPort := OutPort and DataOff[RelayUser];
     Port[$300] := OutPort;    {Off Relay}
     TextColor(0);             {Clear Menu Setup}
     TextBackground(0);
END;

PROCEDURE Input;
BEGIN
InPort := NOT Port[$301];
If InPort <> OldPort Then
   Begin
     OldPort := InPort;
     In1Stas := InPort AND $01;
     InPort  := InPort SHR 1;
     In2Stas := InPort AND $01;
     InPort  := InPort SHR 1;
     In3Stas := InPort AND $01;
     InPort  := InPort SHR 1;
     In4Stas := InPort AND $01;
     InPort  := InPort SHR 1;
     In5Stas := InPort AND $01;
     InPort  := InPort SHR 1;
     In6Stas := InPort AND $01;
     InPort  := InPort SHR 1;
     In7Stas := InPort AND $01;
     InPort  := InPort SHR 1;
     In8Stas := InPort AND $01;
     Gotoxy(21,7);TextColor(ColorStas[In1STAS]);Write(InStas[In1Stas]);  {Input1 Status}
     Gotoxy(26,7);TextColor(ColorStas[In2STAS]);Write(InStas[In2Stas]);  {Input2 Status}
     Gotoxy(31,7);TextColor(ColorStas[In3STAS]);Write(InStas[In3Stas]);  {Input3 Status}
     Gotoxy(36,7);TextColor(ColorStas[In4STAS]);Write(InStas[In4Stas]);  {Input4 Status}
     Gotoxy(41,7);TextColor(ColorStas[In5STAS]);Write(InStas[In5Stas]);  {Input5 Status}
     Gotoxy(46,7);TextColor(ColorStas[In6STAS]);Write(InStas[In6Stas]);  {Input6 Status}
     Gotoxy(51,7);TextColor(ColorStas[In7STAS]);Write(InStas[In7Stas]);  {Input7 Status}
     Gotoxy(56,7);TextColor(ColorStas[In8STAS]);Write(InStas[In8Stas]);  {Input8 Status}
     TextBackground(1);
     TextColor(15);
     Gotoxy(30,13);Write('Please Select is : ');
   End;
END;


PROCEDURE MenuMain;
BEGIN
  TextColor(0);
  TextBackground(0);
  Clrscr;
  TextBackGround(Blue);
  TextColor(Yellow);
  Gotoxy(19,01);Writeln('ͻ');
  Gotoxy(19,02);Writeln(' **>> Example Program For ET-PCREL <<** ');
  Gotoxy(19,03);Writeln(' Relay Output 8 Ch & Input Isolate 8 Ch ');
  Gotoxy(19,04);Writeln('  PC-Card Interface By... ETT CO.,LTD.  ');
  Gotoxy(19,05);Writeln('͹');
  Gotoxy(19,06);Writeln('                                        ');
  Gotoxy(19,07);Writeln('                                        ');
  Gotoxy(19,08);Writeln('                                        ');
  Gotoxy(19,09);Writeln('                                        ');
  Gotoxy(19,10);Writeln('                                        ');
  Gotoxy(19,11);Writeln('      OnRelay      OffRelay     Quit    ');
  Gotoxy(19,12);Writeln('͹');
  Gotoxy(19,13);Writeln('                                        ');
  Gotoxy(19,14);Writeln('ͼ');
  TextColor(12);
  Gotoxy(26,11);Write('O');
  Gotoxy(40,11);Write('f');
  Gotoxy(52,11);Write('Q');
  TextColor(11);
  Gotoxy(21,6);Write('IN1  IN2  IN3  IN4  IN5  IN6  IN7  IN8');
  Gotoxy(21,7);TextColor(ColorStas[In1STAS]);Write(InStas[In1Stas]);  {Input1 Status}
  Gotoxy(26,7);TextColor(ColorStas[In2STAS]);Write(InStas[In2Stas]);  {Input2 Status}
  Gotoxy(31,7);TextColor(ColorStas[In3STAS]);Write(InStas[In3Stas]);  {Input3 Status}
  Gotoxy(36,7);TextColor(ColorStas[In4STAS]);Write(InStas[In4Stas]);  {Input4 Status}
  Gotoxy(41,7);TextColor(ColorStas[In5STAS]);Write(InStas[In5Stas]);  {Input5 Status}
  Gotoxy(46,7);TextColor(ColorStas[In6STAS]);Write(InStas[In6Stas]);  {Input6 Status}
  Gotoxy(51,7);TextColor(ColorStas[In7STAS]);Write(InStas[In7Stas]);  {Input7 Status}
  Gotoxy(56,7);TextColor(ColorStas[In8STAS]);Write(InStas[In8Stas]);  {Input8 Status}

  TextColor(11);
  Gotoxy(21,8);Write('RY1  RY2  RY3  RY4  RY5  RY6  RY7  RY8');
  Gotoxy(21,9);TextColor(ColorStas[RY1STAS]);Write(OutStas[RY1Stas]);  {Relay1 Status}
  Gotoxy(26,9);TextColor(ColorStas[RY2STAS]);Write(OutStas[RY2Stas]);  {Relay2 Status}
  Gotoxy(31,9);TextColor(ColorStas[RY3STAS]);Write(OutStas[RY3Stas]);  {Relay3 Status}
  Gotoxy(36,9);TextColor(ColorStas[RY4STAS]);Write(OutStas[RY4Stas]);  {Relay4 Status}
  Gotoxy(41,9);TextColor(ColorStas[RY5STAS]);Write(OutStas[RY5Stas]);  {Relay5 Status}
  Gotoxy(46,9);TextColor(ColorStas[RY6STAS]);Write(OutStas[RY6Stas]);  {Relay6 Status}
  Gotoxy(51,9);TextColor(ColorStas[RY7STAS]);Write(OutStas[RY7Stas]);  {Relay7 Status}
  Gotoxy(56,9);TextColor(ColorStas[RY8STAS]);Write(OutStas[RY8Stas]);  {Relay8 Status}
END;


BEGIN   {MAIN}
  TextColor(0);
  TextBackground(0);
  Clrscr;
  Port[$303] := $8A; {PortA=Out,PortB=In,PortC Low=Output,PortC High=In}
  OldPort := $00;
  RY1Stas := 0;      {Defualt Status  = off}
  RY2Stas := 0;
  RY3Stas := 0;
  RY4Stas := 0;
  RY5Stas := 0;
  RY6Stas := 0;
  RY7Stas := 0;
  RY8Stas := 0;
  Repeat
    Quit := False;
    Input;
    MenuMain;
    TextBackground(1);
    TextColor(15);
    Gotoxy(30,13);Write('Please Select is : ');
    While NOT Keypressed do
    Input;
    Ch := Readkey;
    Ch := Upcase(Ch);
    CASE Ch OF
      'O' : OnRelay;
      'F' : OffRelay;
      'Q' : Quit := True;
    ELSE Quit := False;
    END;
  Until Quit = True;
  TextColor(15);         {Clear Screen}
  TextBackground(0);
  Clrscr;
END.